<?php
/*
 You may not change or alter any portion of this comment or credits
 of supporting developers from this source code or any supporting source code
 which is considered copyrighted (c) material of the original comment or credit authors.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

xoops_load("gui", "system");

/*
 * Xoops Cpanel oxygen GUI class
 *
 * @copyright   The XOOPS project http://sf.net/projects/xoops/
 * @license     http://www.fsf.org/copyleft/gpl.html GNU public license
 * @package     system
 * @usbpackage  GUI
 * @since       2.3.x
 * @author      Mamba       <mambax7@gmail.com>
 * @author      Mojtabajml  <jamali.mojtaba@gmail.com>
 * @author      Voltan      <djvoltan@gmail.com>
 * @auther      BitC3R0     (Original Author) 
 * @version     1 final
 * @version     $Id$
 */

class XoopsGuiOXYGEN extends /* implements */ XoopsSystemGui
{
    /**
     * Reference to template object
     */
    var $template;

    /**
     * Holding navigation
     */
    var $navigation;

    var $menu;

    function __construct()
    {
        include_once XOOPS_ROOT_PATH . '/class/template.php';
        $this->template = new XoopsTpl();
    }

    function XoopsGuiOXYGEN()
    {
        $this->__construct();
    }

    function validate()
    {
        return true;
    }

    function generateMenu()
    {
        return true;
    }

    function header()
    {
        global $xoopsConfig, $xoopsUser, $xoopsModule;
        xoops_loadLanguage('cpanel', 'system');
        xoops_loadLanguage('modinfo', 'system');
        xoops_loadLanguage('admin', 'system');

        if (!@include_once XOOPS_ROOT_PATH . "/modules/system/class/gui/oxygen/language/" . $xoopsConfig['language'] . '/admin.php') {
            include_once XOOPS_ROOT_PATH . "/modules/system/class/gui/oxygen/language/english/admin.php";
        }

        if (!headers_sent()) {
            header('Content-Type:text/html; charset='._CHARSET);
            header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
            header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
            header('Cache-Control: no-store, no-cache, must-revalidate');
            header("Cache-Control: post-check=0, pre-check=0", false);
            header("Pragma: no-cache");
        }

        $tpl = $this->template;
        $tpl->assign('lang_cp', _CPHOME);
        $tpl->assign('system_options', _AD_SYSOPTIONS);
        $tpl->assign('lang_banners', _MD_AM_BANS);
        $tpl->assign('lang_blocks', _MD_AM_BKAD);
        $tpl->assign('lang_groups', _MD_AM_ADGS);
        $tpl->assign('lang_images', _MD_AM_IMAGES);
        $tpl->assign('lang_modules', _MD_AM_MDAD);
        $tpl->assign('lang_preferences', _MD_AM_PREF);
        $tpl->assign('lang_smilies', _MD_AM_SMLS);
        $tpl->assign('lang_ranks', _MD_AM_RANK);
        $tpl->assign('lang_edituser', _MD_AM_USER);
        $tpl->assign('lang_finduser', _MD_AM_FINDUSER);
        $tpl->assign('lang_mailuser', _MD_AM_MLUS);
        $tpl->assign('lang_avatars', _MD_AM_AVATARS);
        $tpl->assign('lang_tpls', _MD_AM_TPLSETS);
        $tpl->assign('lang_comments', _MD_AM_COMMENTS);
        $tpl->assign('lang_insmodules', _AD_INSTALLEDMODULES);
		$tpl->assign('lang_overview', _MD_CPANEL_OVERVIEW);
		$tpl->assign('lang_phpextensions', _MD_CPANEL_PHPEXTENSIONS);
		$tpl->assign('lang_about_xoops', _MD_OXYGEN_ABOUT);
		$tpl->assign('lang_about_xoops_text', _MD_OXYGEN_ABOUT_TEXT);
		$tpl->assign('lang_version', _MD_OXYGEN_VERSION);
		$tpl->assign('lang_version_xoops', _MD_OXYGEN_VERSION_XOOPS);
		$tpl->assign('lang_version_php', _MD_OXYGEN_VERSION_PHP);
		$tpl->assign('lang_version_mysql', _MD_OXYGEN_VERSION_MYSQL);
		$tpl->assign('lang_server_api_name', _MD_OXYGEN_Server_API);
		$tpl->assign('lang_os', _MD_OXYGEN_OS);
		$tpl->assign('lang_xoops_links', _MD_OXYGEN_XOOPS_LINKS);
        $tpl->assign('lang_xoops_xoopsproject', _MD_OXYGEN_XOOPSPROJECT);
        $tpl->assign('lang_xoops_localsupport', _MD_OXYGEN_LOCALSUPPORT); 
        $tpl->assign('lang_xoops_xoopscore', _MD_OXYGEN_XOOPSCORE);
        $tpl->assign('lang_xoops_xoopsthems', _MD_OXYGEN_XOOPSTHEME);
        $tpl->assign('lang_xoops_xoopswiki', _MD_OXYGEN_XOOPSWIKI);
        $tpl->assign('lang_xoops_xoopsbooks', _MD_OXYGEN_XOOPSBOOKS);
        $tpl->assign('lang_xgiftshop', _MD_OXYGEN_XGIFTSHOP);
        $tpl->assign('lang_xdonations', _MD_OXYGEN_XDONATIONS);
        $tpl->assign('lang_xdonations_text', _MD_OXYGEN_XDONATIONS_TEXT);
        $tpl->assign('lang_xoops_newmodule', _MD_OXYGEN_NEWMODULE);
        $tpl->assign('lang_xoops_xoopsfaq', _MD_OXYGEN_XOOPSFAQ);
        $tpl->assign('lang_xoops_codesvn', _MD_OXYGEN_CODESVN);
        $tpl->assign('lang_xoops_reportbug', _MD_OXYGEN_REPORTBUG);
        //add for styles name
        $tpl->assign('lang_silver',_MD_LANG_SILVER);
        $tpl->assign('lang_dark',_MD_LANG_DARK);
        //start system overview 
        $tpl->assign('lang_xoops_version', XOOPS_VERSION);
        $tpl->assign('lang_php_vesion', PHP_VERSION);
        $tpl->assign('lang_mysql_version', mysql_get_server_info());
        $tpl->assign('lang_server_api', PHP_SAPI);
        $tpl->assign('lang_os_name', PHP_OS);
        $tpl->assign('safe_mode', ini_get( 'safe_mode' ) ? 'On' : 'Off');
        $tpl->assign('register_globals', ini_get( 'register_globals' ) ? 'On' : 'Off');
        $tpl->assign('magic_quotes_gpc', ini_get( 'magic_quotes_gpc' ) ? 'On' : 'Off');
        $tpl->assign('allow_url_fopen', ini_get( 'allow_url_fopen' ) ? 'On' : 'Off');
        $tpl->assign('fsockopen', function_exists( 'fsockopen' ) ? 'On' : 'Off');
        $tpl->assign('allow_call_time_pass_reference', ini_get( 'allow_call_time_pass_reference' ) ? 'On' : 'Off');
        $tpl->assign('post_max_size', ini_get( 'post_max_size' ));
        $tpl->assign('max_input_time', ini_get( 'max_input_time' ));
        $tpl->assign('output_buffering', ini_get( 'output_buffering' ));
        $tpl->assign('max_execution_time', ini_get( 'max_execution_time' ));
        $tpl->assign('memory_limit', ini_get( 'memory_limit' ));
        $tpl->assign('file_uploads', ini_get( 'file_uploads' ) ? 'On' : 'Off');
        $tpl->assign('upload_max_filesize', ini_get( 'upload_max_filesize' ));
        $tpl->assign('xoops_sitename', $xoopsConfig['sitename']);
        
        $lang = '';
        if (file_exists(XOOPS_ROOT_PATH . '/modules/system/class/gui/oxygen/css/' . _LANGCODE . '.css')) {
            $lang .= '<link rel="stylesheet" type="text/css" media="all" href="' . XOOPS_URL . '/modules/system/class/gui/oxygen/css/' . _LANGCODE . '.css" />';
        }
        if (file_exists(XOOPS_ROOT_PATH . '/language/' . $xoopsConfig["language"] . '/style.css')) {
            $lang .= '<link rel="stylesheet" type="text/css" media="all" href="' . XOOPS_URL . '/language/' . $xoopsConfig["language"] . '/style.css" />';
        }
        $tpl->assign('xoops_lang', $lang);

        // ADD MENU *****************************************

        //Add  CONTROL PANEL  Menu  items
        $menu = array();
        $menu[0]['link'] = XOOPS_URL;
        $menu[0]['title'] = _YOURHOME;
        $menu[0]['absolute'] = 1;
        $menu[1]['link'] = XOOPS_URL . "/admin.php?xoopsorgnews=1";
        $menu[1]['title'] = _XOOPS_NEWS;
        $menu[1]['absolute'] = 1;
        $menu[1]['icon'] = XOOPS_URL . '/modules/system/class/gui/oxygen/images/xoops.png';
        $menu[2]['link'] = XOOPS_URL . "/user.php?op=logout";
        $menu[2]['title'] = _LOGOUT;
        $menu[2]['absolute'] = 1;
        $menu[2]['icon'] = XOOPS_URL . '/modules/system/class/gui/oxygen/images/logout.png';
        $tpl->append('navitems', array('link' => XOOPS_URL . '/admin.php', 'text' => _CPHOME, 'menu' => $menu));

        //add SYSTEM  Menu items
        include dirname(__FILE__) . '/menu.php';
        if (empty($xoopsModule) || 'system' == $xoopsModule->getVar('dirname', 'n')) {
            $modpath = XOOPS_URL . '/admin.php';
            $modname = _AD_SYSOPTIONS;
            $modid = 1;
            $moddir = 'system';

            $mod_options = $adminmenu;
            foreach (array_keys($mod_options) as $item) {
                $mod_options[$item]['link'] = empty($mod_options[$item]['absolute']) ? XOOPS_URL . "/modules/system/" . $mod_options[$item]['link'] : $mod_options[$item]['link'];
                $mod_options[$item]['icon'] = empty($mod_options[$item]['icon']) ? '' : XOOPS_URL . "/modules/system/class/gui/oxygen/" . $mod_options[$item]['icon'];
                unset($mod_options[$item]['icon_small']);
            }
        } else {
            $moddir = $xoopsModule->getVar('dirname', 'n');
            $modpath = XOOPS_URL . '/modules/' . $moddir;
            $modname = $xoopsModule->getVar('name');
            $modid = $xoopsModule->getVar('mid');

            $mod_options = $xoopsModule->getAdminMenu();
            foreach (array_keys($mod_options) as $item) {
                $mod_options[$item]['link'] = empty($mod_options[$item]['absolute']) ? XOOPS_URL . "/modules/{$moddir}/" . $mod_options[$item]['link'] : $mod_options[$item]['link'];
                $mod_options[$item]['icon'] = empty($mod_options[$item]['icon']) ? '' : XOOPS_URL . "/modules/{$moddir}/" . $mod_options[$item]['icon'];
            }
        }

        $tpl->assign('mod_options', $mod_options);
        $tpl->assign('modpath', $modpath);
        $tpl->assign('modname', $modname);
        $tpl->assign('modid', $modid);
        $tpl->assign('moddir', $moddir);

        // add MODULES  Menu items
        $module_handler =& xoops_gethandler('module');
        $criteria = new CriteriaCompo();
        $criteria->add(new Criteria('hasadmin', 1));
        $criteria->add(new Criteria('isactive', 1));
        $criteria->setSort('mid');
        $mods = $module_handler->getObjects($criteria);

        $menu = array();
        $moduleperm_handler =& xoops_gethandler('groupperm');
        foreach ($mods as $mod) {
            $rtn = array();
			$modOptions = array(); //add for sub menus
            $sadmin = $moduleperm_handler->checkRight('module_admin', $mod->getVar('mid'), $xoopsUser->getGroups());
            if ($sadmin) {
                $info = $mod->getInfo();
                if (!empty($info['adminindex'])) {
                    $rtn['link'] = XOOPS_URL . '/modules/'. $mod->getVar('dirname', 'n') . '/' . $info['adminindex'];
                } else {
                    $rtn['link'] = XOOPS_URL . '/modules/system/admin.php?fct=preferences&amp;op=showmod&amp;mod=' . $mod->getVar('mid');
                }
                $rtn['title'] = $mod->name();
                $rtn['absolute'] = 1;
				$rtn['url'] = XOOPS_URL . '/modules/'. $mod->getVar('dirname', 'n') . '/'; //add for sub menus
				$modOptions = $mod->getAdminMenu();                                        //add for sub menus
				$rtn['options'] = $modOptions;                                             //add for sub menus
				
                if (isset($info['icon']) && $info['icon'] != '' ) {
                    $rtn['icon'] = XOOPS_URL . '/modules/' . $mod->getVar('dirname', 'n') . '/' . $info['icon'];
                }
            }
            $menu[] = $rtn;
        }
        $tpl->append('navitems', array('link' => XOOPS_URL . '/modules/system/admin.php?fct=modulesadmin', 
		'text' => _MD_AM_MDAD, 'dir' => $mod->getVar('dirname', 'n'), 'menu' => $menu));

        
        // add preferences menu
        $menu = array();
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=1',
            'title'     => _MD_OXYGEN_GENERAL,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=2',
            'title'     => _MD_OXYGEN_USERSETTINGS,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=3',
            'title'     => _MD_OXYGEN_METAFOOTER,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=4',
            'title'     => _MD_OXYGEN_CENSOR,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=5',
            'title'     => _MD_OXYGEN_SEARCH,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=6',
            'title'     => _MD_OXYGEN_MAILER,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        $menu[] = array(
            'link'      => XOOPS_URL . '/modules/system/admin.php?fct=preferences&op=show&confcat_id=7',
            'title'     => _MD_OXYGEN_AUTHENTICATION,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png');
        foreach ($mods as $mod) {
            $rtn = array();
            $sadmin = $moduleperm_handler->checkRight('module_admin', $mod->getVar('mid'), $xoopsUser->getGroups());
            if ($sadmin) {
                $info = $mod->getInfo();
                $rtn['link'] = XOOPS_URL . '/modules/system/admin.php?fct=preferences&amp;op=showmod&amp;mod=' . $mod->getVar('mid');
                $rtn['title'] = $mod->name();
                $rtn['absolute'] = 1;
                $rtn['icon'] = XOOPS_URL . '/modules/system/class/gui/oxygen/images/navIcons/prefs_small.png';
            }
            $menu[] = $rtn;
        }
        $tpl->append('navitems', array('link' => XOOPS_URL . '/modules/system/admin.php?fct=preferences', 'text' => _MD_OXYGEN_SITEPREF, 'dir' => $mod->getVar('dirname', 'n'), 'menu' => $menu));
        
        
        
        
        //add OPTIONS/Links Menu Items
        $menu = array();
        $menu[] = array(
            'link'      => "http://www.xoops.org",
            'title'     => ـXOOPS_WEBSITE,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/xoops.png');
        $menu[] = array(
            'link'      => "http://www.xoops.org/modules/extgallery/",
            'title'     => _AD_XOOPSTHEMES,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/tweb.png');
        $menu[] = array(
            'link'      => "http://www.xoops.org/modules/repository/",
            'title'     => _MD_AM_MDAD,
            'absolute'  => 1,
            'icon'     => XOOPS_URL . '/modules/system/class/gui/oxygen/images/xoops.png');
        $menu[] = array(
            'link'      => "http://sourceforge.net/projects/xoops/",
            'title'     => ـSOURCEFORGE,
            'absolute'  => 1);

        $tpl->append('navitems', array('link' => XOOPS_URL . '/admin.php','text' => _AD_INTERESTSITES, 'menu' => $menu));

        echo $tpl->fetch(XOOPS_ROOT_PATH . '/modules/system/class/gui/oxygen/templates/admin/system_adm_header.html');
        echo $tpl->fetch(XOOPS_ROOT_PATH . '/modules/system/class/gui/oxygen/templates/admin/system_adm_navbar.html');
        echo "<div id='containBodyCP'><br /><div id='bodyCP'>";

        if (is_object($xoopsModule) || !empty($_GET['xoopsorgnews'])) {
            return;
        }

        foreach ($mods as $mod) {
            $rtn = array();
            $moduleperm_handler =& xoops_gethandler('groupperm');
            $sadmin = $moduleperm_handler->checkRight('module_admin', $mod->getVar('mid'), $xoopsUser->getGroups());
            if ($sadmin) {
                $info = $mod->getInfo();
                if (!empty($info['adminindex'])) {
                    $rtn['link'] = XOOPS_URL . '/modules/'. $mod->getVar('dirname', 'n') . '/' . $info['adminindex'];
                } else {
                    $rtn['link'] = XOOPS_URL . '/modules/system/admin.php?fct=preferences&amp;op=showmod&amp;mod=' . $mod->getVar('mid');
                }
                $rtn['title'] = $mod->getVar('name');
                $rtn['absolute'] = 1;
                if (isset($info['icon_big'])) {
                    $rtn['icon'] = XOOPS_URL . '/modules/' . $mod->getVar('dirname', 'n') . '/' . $info['icon_big'];
                } elseif (isset($info['image'])) {
                    $rtn['icon'] = XOOPS_URL . '/modules/' . $mod->getVar('dirname', 'n') . '/' . $info['image'];
                }
            }
            $tpl->append('modules', $rtn);
        }

        echo $tpl->fetch(XOOPS_ROOT_PATH . '/modules/system/class/gui/oxygen/templates/admin/system_indexcp.html');
    }

    function footer()
    {
        echo $this->template->fetch(XOOPS_ROOT_PATH . '/modules/system/class/gui/oxygen/templates/admin/system_adm_footer.html');
        echo $GLOBALS['xoopsLogger']->render('');
        ob_end_flush();
        return true;
    }
}

?>